/******************************************************************************
 *
 *	Pocket Balloon
 *	color edition
 *	PalmOS 5
 *	ver 1.1.0
 *	2008. 4
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#define DEBUG
//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
void init_stage( void );
void init_level( void );
void init_player( void );
void init_stars( void );

void operate_key_and_pen( void );

void draw_stage( void );
void draw_player( void );
void draw_start_point( void );
void draw_sea( void );
void draw_thorn( void );
void draw_cloud( void );
void draw_balloon( void );
void draw_bubble( void );
void draw_thander( void );
void draw_stars( void );
void draw_fish( void );

void move_player( void );
void move_thorn( void );
void move_thander( void );
void move_cloud( void );
void move_bubble( void );

void animetion( void );

void scroll_thorn( void );
void scroll_balloon( void );
void scroll_stars( void );

void set_new_thorn_and_balloon( void );
void set_new_balloon( void );
void set_thander( void );

void rank_up( void );

Boolean is_hit_balloon( BalloonType * );
Boolean is_hit_bubble( void );
Boolean is_hit_thander( ThanderType * );

void check_hit_thorn( ThornType * );
void check_over( void );



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/
//// Xe[Wf[^iŒj26
// gQgQ
static const int stage_thorn[][2]
= {
  { 144, -1 }, { 48, 152 }, { 56, 152 }, { 64, 152 }, { 152, -1 }, { 152, -1 },
  { -1, -1 }, { -1, -1 }, { 72, -1 }, { 72, -1 }, { 80, -1 }, { 88, -1 }, { 88, -1 },
  { 32, 152 }, { 40, 144 }, { 48, 136 }, { 56, 128 }, { -1, -1 }, { 88, -1 }, { 80, 96 }, { 88, -1 },
  { -1, -1 }, { 56, 128 }, { 48, 136 }, { 40, 144 }, { 32, 152 }
};

// ACeiDj
static const int stage_balloon[][2]
= {
  { 32, 120 }, { 64, -1 }, { -1, -1 }, { -1, -1 }, { -1, -1 }, { 128, -1 },
  { -1, -1 }, { 40, -1 }, { 80, -1 }, { 150, -1 }, { -1, -1 }, { -1, -1 }, { -1, -1 },
  { -1, -1 }, { -1, -1 }, { 64, -1 }, { -1, -1 }, { -1, -1 }, { -1, -1 }, { 32, -1 },
  { 152, -1 }, { -1, -1 }, { -1, -1 }, { -1, -1 }, { -1, -1 }, { 58, 128 }
};


/************************************************
 *	^Cg XN[
 ***********************************************/
void
title_back( void )
{
  clear_screen();
  scroll_stars();
  draw_stars();
}



/************************************************
 *	Q[JnO XN[
 ***********************************************/
void
pre_start( void )
{
  if( (g_gs.player.start_x >> 16) > 152+BACK_W_BLANK )
    {
      set_start_position();
      g_gs.start = FLG_GAME_START;	//X^[g
      return;
    }

  clear_screen();

  draw_sea();
  scroll_stars();
  draw_stage();

  animetion();

  draw_player();
  draw_thorn();
  draw_balloon();
  draw_start_point();

  // XN[
  g_gs.player.start_x += DEF_SCROLL_INC;
  if( g_gs.player.x < (144+BACK_W_BLANK) *65536 )
    {
      g_gs.player.x += DEF_SCROLL_INC;
    }
}



/************************************************
 *	X^[g̏
 ***********************************************/
void set_start_position( void )
{
  g_gs.player.x -= 4*65536;	// -4dot ͂΂iHj
}



/************************************************
 *	Q[̏
 ***********************************************/
void
init_game_status( void )
{
  g_gs.start = FLG_GAME_START | FLG_GAME_TITLE;	// Q[^Cg
  g_gs.key = g_gs.keyf = 0;			// L[̓tO
  g_gs.se = no_sound;

  g_gs.score = 0;				// XRA

  g_gs.anime_counter = 0;			// AjpJE^

  // @
  init_player();
  // Xe[W
  init_stage();
  // x
  init_level();
}



/************************************************
 *	Q[̃C
 ***********************************************/
void
play_game( void )
{
  if( TimGetTicks() < g_event_interval + DEF_EVENT_TICK ) return;
  if( !(g_gs.start & FLG_GAME_START) ) return;

  // TickXV
  g_event_interval = TimGetTicks();

  get_hard_key();		// n[hL[擾

  if( !select_game_event() )	// eQ[pCxg
    {
      clear_screen();
      draw_sea();		// BGiCj`

      animetion();		// Aj

      move_player();		// @ړ
      draw_player();		// @\

      draw_stage();		// Xe[W`
      check_over();		// Q[I[o[ȁH
    }
  change_se();			// ʉ؂芷
  show_status();		// Xe[^X\
  copy_buff_to_lcd();		// obNXN[LCDɃRs[
  sound();			// ʉit[j
}



/********************************************************************
 *	X^[eBbNȊ֐Q
 *******************************************************************/

/************************************************
 *	Xe[W`
 ***********************************************/
static void
draw_stage( void )
{
  if( !g_gs.stage.stop_interval )
    {
      if( !(--g_gs.stage.new_interval) )
        {
          g_gs.stage.new_interval = DEF_NEW_OBJ_INTERVAL;	// ̃IuWFNgo܂
          rank_up();				// NAbvJEg

          if( (--g_gs.lv.count) < DEF_RANK_NEXT_BLANK )// NAbv̋󔒎
            set_new_balloon();			// D̂ݔzu  
          else
            set_new_thorn_and_balloon();	// gQgQ, Dzu
        }

      scroll_stars();	// XN[
      scroll_thorn();

      move_thorn();	// LN^ړ
      move_cloud();
      move_thander();
      move_bubble();
    }
  else
    {
      g_gs.stage.stop_interval--;
      if( !(g_gs.stage.stop_interval & 7) )
        set_se( tick );	// v̉
    }
  scroll_balloon();

  draw_stars();		// LN^`
  draw_balloon();
  draw_thorn();
  draw_cloud();
  draw_thander();
  draw_bubble();
  draw_fish();
}



/************************************************
 *	x̏
 ***********************************************/
static void
init_level( void )
{
  // x
  g_gs.lv.rank = 50;
  g_gs.lv.count = DEF_STAGE_LIMIT + DEF_RANK_NEXT_BLANK;
}



/************************************************
 *	gQgQ㉺ړ
 ***********************************************/
static void
move_thorn( void )
{
  int i, max = g_gs.stage.thorn_num;


  for( i = 0; i < max; i++ )
    {
      if( g_gs.stage.thorn_p[i].type )
        {
          // ㉺ړ
          g_gs.stage.thorn_p[i].y
            += g_gs.stage.thorn_p[i].speed * g_gs.stage.thorn_p[i].type;

          if( g_gs.stage.thorn_p[i].y < (16+BACK_H_BLANK) *65536 )
            {
              g_gs.stage.thorn_p[i].y = (16+BACK_H_BLANK) *65536;
              g_gs.stage.thorn_p[i].type = 1; // ړ]
            }
          else if( g_gs.stage.thorn_p[i].y > (136+BACK_H_BLANK) *65536 )
            {
              g_gs.stage.thorn_p[i].y = (136+BACK_H_BLANK)*65536;
              g_gs.stage.thorn_p[i].type = -1; // ړ]
            }
        }
    }
}



/************************************************
 *	VLZbg
 ***********************************************/
static void
set_new_thorn_and_balloon( void )
{
  int i;


  if( g_gs.stage.mode < DEF_STAGE_LIMIT )
    {
      ////// GŒ胂[h
      for( i = 0; i < 2; i++ )
        {
          if( stage_thorn[ g_gs.stage.mode ][i] == -1 )
            break;
          // gQgQ
          g_gs.stage.thorn_p[g_gs.stage.thorn_num].type = 0;
          g_gs.stage.thorn_p[g_gs.stage.thorn_num].x = 6*65536;
          g_gs.stage.thorn_p[g_gs.stage.thorn_num].y
            = (Int32)stage_thorn[g_gs.stage.mode][i] << 16;

          g_gs.stage.thorn_num++;
        }
      for( i = 0; i < 2; i++ )
        {
          if( stage_balloon[ g_gs.stage.mode ][i] == -1 )
            break;
          // ACeiDj
          g_gs.stage.balloon_p[g_gs.stage.balloon_num].x = 6*65536;
          g_gs.stage.balloon_p[g_gs.stage.balloon_num].y
            = (Int32)stage_balloon[g_gs.stage.mode][i] << 16;

          g_gs.stage.balloon_num++;
        }
      g_gs.stage.mode++;
    }
  else
    {
      ////// Gړ[h
      // gQgQ
      g_gs.stage.thorn_p[g_gs.stage.thorn_num].type
        = ( RND( 8 ) & 2 ) - 1; // -1 or 1
      g_gs.stage.thorn_p[g_gs.stage.thorn_num].x
        = 6*65536;
      g_gs.stage.thorn_p[g_gs.stage.thorn_num].y
        = (Int32)(RND( 120 ) + 16 + BACK_H_BLANK) << 16; // 16 - 136
      // Xs[h
      g_gs.stage.thorn_p[g_gs.stage.thorn_num].speed
        = (Int32)(RND(8)+1) << 13; // 8iK

      g_gs.stage.thorn_num++;

      if( RND(2) || g_gs.stage.balloon_num >= MAX_BALLOON )
        return;
      // ACeiDj
      g_gs.stage.balloon_p[g_gs.stage.balloon_num].type
        = RND( 3 ) ? 0 : 1;
      g_gs.stage.balloon_p[g_gs.stage.balloon_num].x
        = 6*65536;
      g_gs.stage.balloon_p[g_gs.stage.balloon_num].y
        = (Int32)(RND( 120 ) +16+BACK_H_BLANK) << 16;

      g_gs.stage.balloon_num++;
    }
}



/************************************************
 *	ACeiDjZbg
 ***********************************************/
static void
set_new_balloon( void )
{
  if( RND(3) || g_gs.stage.balloon_num >= MAX_BALLOON )
    return;

  g_gs.stage.balloon_p[g_gs.stage.balloon_num].type = RND( 3 ) ? 0 : 1;
  g_gs.stage.balloon_p[g_gs.stage.balloon_num].x  = 6*65536;
  g_gs.stage.balloon_p[g_gs.stage.balloon_num].y
    = (Int32)(RND( 120 ) +16+BACK_H_BLANK) << 16;

  g_gs.stage.balloon_num++;
}



/************************************************
 *	gQgQXN[
 ***********************************************/
static void
scroll_thorn( void )
{
  int i, max = g_gs.stage.thorn_num;
  ThornType *curr_p, *end_p;


  if( !g_gs.stage.thorn_num ) return;

  // obt@̌납瑀삷
  curr_p = end_p = g_gs.stage.thorn_p + (g_gs.stage.thorn_num-1);

  for( i = max; i > 0; i--, curr_p-- )
    {
      // 蔻
      check_hit_thorn( curr_p );
      // XN[
      curr_p ->x += DEF_SCROLL_INC;
      if( curr_p ->x > (160+BACK_W_BLANK)*65536 )
        {
          // obt@l߂
          MemMove( curr_p, end_p, sizeof( ThornType ) );
          end_p--;
          g_gs.stage.thorn_num--;
        }
    }
}



/************************************************
 *	DXN[
 ***********************************************/
static void
scroll_balloon( void )
{
  int i, max = g_gs.stage.balloon_num;
  BalloonType *curr_p, *end_p;


  if( !g_gs.stage.balloon_num ) return;

  // obt@̌납瑀삷
  curr_p = end_p = g_gs.stage.balloon_p + (g_gs.stage.balloon_num-1);

  for( i = max; i > 0; i--, curr_p-- )
    {
      // XN[
      if( !g_gs.stage.stop_interval )
        curr_p ->x += DEF_SCROLL_INC;

      if( curr_p ->x > (160+BACK_W_BLANK)*65536 || is_hit_balloon( curr_p ) )
        {
          // obt@l߂
          MemMove( curr_p, end_p, sizeof( BalloonType ) );
          end_p--;
          g_gs.stage.balloon_num--;
        }
    }
}



/************************************************
 *	ACe蔻
 ***********************************************/
static Boolean
is_hit_balloon( BalloonType *p )
{
  if( (UInt16)(g_gs.player.x >> 16) - (UInt16)(p ->x >> 16) +PLAYER_WIDTH < PLAYER_WIDTH + BALLOON_WIDTH + 1
      &&(UInt16)(g_gs.player.y >> 16) - (UInt16)(p ->y >> 16) +PLAYER_HEIGHT < PLAYER_HEIGHT + BALLOON_HEIGHT + 1)
    {
      // XRAZ
      g_gs.score += p ->type * 300 + 100 + ( 50 - g_gs.lv.rank ) * 10;
      if( ++g_gs.stage.balloon_get_count >= DEF_BONUS_COUNT )
        {
          g_gs.stage.balloon_get_count = 0;
          g_gs.score += DEF_BONUS_SCORE; // {[iX_
          set_se( bonus );
        }
      else
        {
          set_se( balloon );
        }
      return true;
    }

  return false;
}



/************************************************
 *	gQgQ蔻
 ***********************************************/
static void
check_hit_thorn( ThornType *p )
{
#ifndef DEBUG

  if( (UInt16)(((p ->x) >> 16)+THORN_X_CENTER) - (UInt16)(g_gs.player.x >> 16) < PLAYER2_WIDTH + 1
      &&(UInt16)(((p ->y) >> 16)+THORN_Y_CENTER) - (UInt16)(g_gs.player.y >> 16) < PLAYER2_HEIGHT + 1
      && !g_gs.player.dead_flg )
    {
      g_gs.player.dead_flg = true; // pCbgDj
      set_se( thorn );
    }

#endif
}



/************************************************
 *	NAbv
 ***********************************************/
static void
rank_up( void )
{
  if( !g_gs.lv.count && g_gs.lv.rank > 1)
    {
      g_gs.lv.rank--;
      g_gs.lv.count = DEF_RANK_UP_COUNT;
    }
}



/************************************************
 *	`
 ***********************************************/
static void
draw_fish( void )
{
  if( g_gs.player.y >= FISH_BORDER )
    {
      g_gs.stage.fish.count --;
    }
  else
    {
      g_gs.stage.fish.count = DEF_FISH_COUNT; // JEgZbg
    }

  // o
  if( g_gs.stage.fish.count < DEF_FISH_ENCOUNT )
    {
      sprite( (g_gs.player.x >> 16)-8,
               DEF_FISH_Y_POS,
               g_chr_handle[ CHR_FISH_0 + (g_gs.stage.fish.count / FISH_INTERVAL) ] );

      if( g_gs.stage.fish.count < (FISH_INTERVAL * 2))
        {
          g_gs.player.eat_flg = true;
          if ( g_gs.stage.fish.count == 0 )
            {
              // Q[I[o[
              g_gs.start = FLG_GAME_START | FLG_GAME_OVER;
              g_gs.over_se = true;
              set_se( thorn );
              g_mes_wait = DEF_MES_WAIT;
            }
        }
    }
}



/************************************************
 *	Q[I[o[
 ***********************************************/
static void
check_over( void )
{
  if( g_gs.player.y > GAME_OVER_BORDER )
    {
      g_gs.start = FLG_GAME_START | FLG_GAME_OVER;
      g_gs.over_se = true;
      g_mes_wait = DEF_MES_WAIT;
    }
}



/************************************************
 *	Xe[W
 ***********************************************/
static void
init_stage( void )
{
  int i;
  static const int stage[][2]
    = { { 66, 56 }, { 56, 48 }, { 46, 40 }, { 6, 144 } }; // Xe[Wf[^
  static const int balloon_data[]
    = { 56, 64 };


  // eobt@
  MemSet( g_gs.stage.thorn_p, sizeof( ThornType ) * MAX_THORN, 0 );
  MemSet( g_gs.stage.balloon_p, sizeof( BalloonType ) * MAX_BALLOON, 0 );
  MemSet( g_gs.stage.thander_p, sizeof( ThanderType ) * MAX_THANDER, 0 );
  MemSet( g_gs.stage.star_p, sizeof( StarType ) * MAX_STAR, 0 );

  g_gs.stage.cloud.live_flg  = false;		// tO
  g_gs.stage.bubble.live_flg = false;

  g_gs.stage.thorn_num = 4;
  g_gs.stage.balloon_num = 1;
  g_gs.stage.thander_num = 0;

  g_gs.stage.balloon_get_count = 0;		// ACeAQbgJEg

  g_gs.stage.mode = 0;				// [hؑփJE^
  g_gs.stage.new_interval = DEF_NEW_OBJ_INTERVAL;	// ̏o܂
  g_gs.stage.stop_interval = 0;			// XN[~JE^

  // gQgQZbg
  for( i = 0; i < 4; i++ )
    {
      g_gs.stage.thorn_p[i].type = 0;
      g_gs.stage.thorn_p[i].x = (Int32)stage[i][0] << 16;
      g_gs.stage.thorn_p[i].y = (Int32)stage[i][1] << 16;
    }

  // DZbg
  g_gs.stage.balloon_p[0].x = (Int32)balloon_data[0] << 16;
  g_gs.stage.balloon_p[0].y = (Int32)balloon_data[1] << 16;
  // 
  init_stars();
}



/************************************************
 *	_ړ
 ***********************************************/
static void
move_cloud( void )
{
  // Zbg
  if( (!g_gs.stage.cloud.live_flg)
      && RND( 180 ) == 0
      && g_gs.lv.rank < 46 )
    {
      g_gs.stage.cloud.live_flg = true;
      g_gs.stage.cloud.x = 0;
      g_gs.stage.cloud.y = (16+BACK_H_BLANK) *65536;
    }

  // ړ
  if( g_gs.stage.cloud.live_flg )
    {
      if( RND( 50 ) == 0
          && g_gs.stage.thander_num < MAX_THANDER )
        {
          // 
          set_thander();
        }
      else
        {
          g_gs.stage.cloud.x += DEF_CLOUD_SCROLL;

          if( g_gs.stage.cloud.x > (160+BACK_W_BLANK)*65536 )
            {
              // _
              g_gs.stage.cloud.live_flg = false;
            }
        }
    }
}



/************************************************
 *	_`
 ***********************************************/
static void
draw_cloud( void )
{
  if( !g_gs.stage.cloud.live_flg ) return;

  sprite( g_gs.stage.cloud.x >> 16,
           g_gs.stage.cloud.y >> 16,
           g_chr_handle[ CHR_CLOUD ] );

  sprite( (g_gs.stage.cloud.x >> 16) + 16,
           g_gs.stage.cloud.y >> 16,
           g_chr_handle[ CHR_CLOUD ] );
}



/************************************************
 *	Zbg
 ***********************************************/
static void
set_thander( void )
{
  g_gs.stage.thander_p[ g_gs.stage.thander_num ].x
    = g_gs.stage.cloud.x + 16*65536;
  g_gs.stage.thander_p[ g_gs.stage.thander_num ].y
    = g_gs.stage.cloud.y;

  g_gs.stage.thander_num++;
}



/************************************************
 *	ړ
 ***********************************************/
static void
move_thander( void )
{
  int i, max = g_gs.stage.thander_num;
  ThanderType *curr_p, *end_p;


  if( !g_gs.stage.thander_num ) return;

  // obt@̌납瑀삷
  curr_p = end_p = g_gs.stage.thander_p + (g_gs.stage.thander_num-1);

  for( i = max; i > 0; i--, curr_p-- )
    {
      // ړ
      curr_p ->x += 1*65536; // 1dot
      curr_p ->y += 1*65536;

      if( curr_p ->x > (160+BACK_W_BLANK)*65536
          || curr_p ->y > (DEF_THANDER_LIMIT+BACK_H_BLANK)*65536
          || is_hit_thander( curr_p ) )
        {
          // obt@l߂
          MemMove( curr_p, end_p, sizeof( ThanderType ) );
          end_p--;
          g_gs.stage.thander_num--;
        }
    }
}



/************************************************
 *	`
 ***********************************************/
static void
draw_thander( void )
{
  int i, max = g_gs.stage.thander_num;


  if( !g_gs.stage.thander_num ) return;

  for( i = 0; i < max; i++ )
    {
      sprite( g_gs.stage.thander_p[i].x >> 16,
               g_gs.stage.thander_p[i].y >> 16,
               g_chr_handle[ CHR_THANDER ] );
    }
}



/************************************************
 *	AZbg, ړ
 ***********************************************/
static void
move_bubble( void )
{
  // Zbg
  if( (!g_gs.stage.bubble.live_flg)
      && RND( 180 ) == 0
      && g_gs.lv.rank <= 49 )
    {
      g_gs.stage.bubble.x = (Int32)(RND( 144 ) + BACK_W_BLANK) << 16; // 16 - 144;
      g_gs.stage.bubble.y = 160 * 65536;
      g_gs.stage.bubble.live_flg = true;
    }

  // ړ
  if( g_gs.stage.bubble.live_flg )
    {
      g_gs.stage.bubble.x += ((RND(8) & 2)-1) *(65536/2); // 0.5dot
      g_gs.stage.bubble.y -= (65536/1);

      if( g_gs.stage.bubble.x < 0
          || g_gs.stage.bubble.x > (160+BACK_W_BLANK) *65536
          || g_gs.stage.bubble.y < (BACK_H_BLANK)*65536
          || is_hit_bubble() )
        {
          g_gs.stage.bubble.live_flg = false;
        }
    }
}



/************************************************
 *	A`
 ***********************************************/
static void
draw_bubble( void )
{
  int anime
    = (g_gs.anime_counter & DEF_ANIME_INTERVAL_BUBBLE) / DEF_ANIME_INTERVAL_BUBBLE_DIV;


  if( !g_gs.stage.bubble.live_flg ) return;
  
  sprite( g_gs.stage.bubble.x >> 16,
           g_gs.stage.bubble.y >> 16,
           g_chr_handle[ CHR_BUBBLE + anime ] );
}



/************************************************
 *	A蔻
 ***********************************************/
static Boolean
is_hit_bubble( void )
{
  if( (UInt16)(g_gs.player.x >> 16) - (UInt16)(g_gs.stage.bubble.x >> 16) + PLAYER_WIDTH
      < (UInt16)(PLAYER_WIDTH + BUBBLE_WIDTH + 1)
      && (UInt16)(g_gs.player.y >> 16) - (UInt16)(g_gs.stage.bubble.y >> 16) + PLAYER_HEIGHT
      < (UInt16)(PLAYER_HEIGHT + BUBBLE_HEIGHT + 1) )
    {
      // XRA
      g_gs.score += SCORE_BUBBLE;
      // ʒ~
      g_gs.stage.stop_interval = DEF_STOP_INTERVAL;
      set_se( balloon );

      return true;
    }

  return false;
}



/************************************************
 *	蔻
 ***********************************************/
static Boolean
is_hit_thander( ThanderType *p )
{
  if( (UInt16)(g_gs.player.x >> 16) - (UInt16)(p ->x >> 16) + PLAYER_WIDTH
      < (UInt16)(PLAYER_WIDTH + THANDER_WIDTH + 1)
      && (UInt16)(g_gs.player.y >> 16) - (UInt16)(p ->y >> 16) + PLAYER_HEIGHT
      < (UInt16)(PLAYER_HEIGHT + THANDER_HEIGHT + 1) )
    {
      g_gs.player.dead_flg = true; // pCbgDj
      set_se( thorn );

      return true;
    }

  return false;
}



/************************************************
 *	@ړ
 ***********************************************/
static void
move_player( void )
{
  int x, y;


  if( g_gs.player.eat_flg ) return;

  // L[
  operate_key_and_pen();

  // Xx
  g_gs.player.x += g_gs.player.vx;
  x = g_gs.player.x >> 16;

  if( x < BACK_W_BLANK )
    {
      g_gs.player.x = (Int32)16 << 16;
      g_gs.player.vx = 0;
    }
  else if( x > 144+BACK_W_BLANK )
    {
      g_gs.player.x = (Int32)(144+BACK_W_BLANK) << 16;
      g_gs.player.vx = 0;
    }

  // Yx
  g_gs.player.y += g_gs.player.vy;
  y = g_gs.player.y >> 16;

  if( y < 16 + BACK_H_BLANK )
    {
      g_gs.player.y = (Int32)(16+BACK_H_BLANK) << 16;
      g_gs.player.vy = g_gs.player.vy * -1; // ˕Ԃ
      set_se( bound );
    }

  y = g_gs.player.vy >> 8;
  // d
  if( y <= DEF_LIMIT_VY ) // x 0.9...
    {
      g_gs.player.vy += DEF_GRAVITY;
    }
}



/************************************************
 *	L[y
 ***********************************************/
static void
operate_key_and_pen( void )
{
  static int key_repeat = DEF_PLAYER_KEY_REPEAT; // L[s[gpEFCg
  int x, vx, vy;
  Boolean jump_flg = false;


  if( g_gs.player.dead_flg ) return;

  vy = g_gs.player.vy >> 8;
  vx = g_gs.player.vx >> 8;
  x = g_gs.player.x >> 16;

  if( g_gs.keyf & KEY_1 && vy >= -DEF_LIMIT_VY )
    {
      g_gs.player.vy -= DEF_VY_JUMP;		// Wv
      g_gs.player.anime_wait = DEF_FLAP_WAIT;	// ͂΂AjpEFCg
      key_repeat = DEF_PLAYER_KEY_REPEAT;
      jump_flg = true;
      if( !g_gs.stage.stop_interval )
        set_se( jump );
    }
  else if( g_gs.key & KEY_2 && vy >= -DEF_LIMIT_VY && !(--key_repeat) )
    {
      g_gs.player.vy -= DEF_VY_JUMP;		// AWv
      g_gs.player.anime_wait = DEF_FLAP_WAIT;
      key_repeat = DEF_PLAYER_KEY_REPEAT;
      jump_flg = true;
      if( !g_gs.stage.stop_interval )
        set_se( jump );
    }

#ifndef DEBUG

  if( ( g_gs.key & KEY_3 || g_gs.key & KEY_NAV_LEFT ) && jump_flg && vx >= -DEF_LIMIT_VX
      || g_gs.pen_down && (g_gs.pen_x < x) && jump_flg && vx >= -DEF_LIMIT_VX )
    {
      g_gs.player.vx -= DEF_VX_LEFT;		// 
      g_gs.player.anime_wait = DEF_FLAP_WAIT;
      g_gs.player.direc = DEF_PLAYER_LEFT;
    }
  else if( ( g_gs.key & KEY_4 || g_gs.key & KEY_NAV_RIGHT ) && jump_flg && vx <= DEF_LIMIT_VX
           || g_gs.pen_down && (g_gs.pen_x > (x+16)) && jump_flg && vx <= DEF_LIMIT_VX )
    {
      g_gs.player.vx += DEF_VX_RIGHT;		// E
      g_gs.player.direc = DEF_PLAYER_RIGHT;
      g_gs.player.anime_wait = DEF_FLAP_WAIT;
    }

#else // foOp

  if( g_gs.key & KEY_3 && vx >= -DEF_LIMIT_VX
      || g_gs.pen_down && (g_gs.pen_x < x) && vx >= -DEF_LIMIT_VX )
    {
      g_gs.player.vx -= DEF_VX_LEFT;		// 
      g_gs.player.anime_wait = DEF_FLAP_WAIT;
      g_gs.player.direc = DEF_PLAYER_LEFT;
    }
  else if( g_gs.key & KEY_4 && vx<= DEF_LIMIT_VX
           || g_gs.pen_down && (g_gs.pen_x > (x+16)) && vx <= DEF_LIMIT_VX )
    {
      g_gs.player.vx += DEF_VX_RIGHT;		// E
      g_gs.player.direc = DEF_PLAYER_RIGHT;
      g_gs.player.anime_wait = DEF_FLAP_WAIT;
    }

#endif
}



/************************************************
 *	@
 ***********************************************/
static void
init_player( void )
{
  // W
  g_gs.player.x = DEF_PLAYER_X;
  g_gs.player.y = DEF_PLAYER_Y;
  g_gs.player.vx = DEF_PLAYER_VX;
  g_gs.player.vy = DEF_PLAYER_VY;
  
  g_gs.player.direc = DEF_PLAYER_LEFT;
  g_gs.player.eat_flg = false;
  g_gs.player.dead_flg = false;
  g_gs.over_se = false;

  // Ajp̃EFCg
  g_gs.player.anime_wait = 0;

  // X^[gC
  g_gs.player.start_x = DEF_START_X;
  g_gs.player.start_y = DEF_START_Y;
}



/************************************************
 *	@`
 ***********************************************/
static void
draw_player( void )
{
  Coord x = g_gs.player.x >> 16;
  Coord y = g_gs.player.y >> 16;


  if( g_gs.player.eat_flg ) return;

  if( g_gs.player.dead_flg )
    {
      sprite( x, y, g_chr_handle[ CHR_DEAD ] );
      return;
    }

  if( g_gs.player.anime_wait )
    {
      sprite( x, y, g_chr_handle[ CHR_PLAYER_L + g_gs.player.direc +1 ] ); // ͂΂
      g_gs.player.anime_wait--;
    }
  else
    {
      sprite( x, y, g_chr_handle[ CHR_PLAYER_L + g_gs.player.direc ] ); // m[}
    }
}



/************************************************
 *	gQgQ`
 ***********************************************/
static void
draw_thorn( void )
{
  int i, anime, max = g_gs.stage.thorn_num;


  if( !g_gs.stage.thorn_num ) return;

  anime = (g_gs.anime_counter & DEF_ANIME_INTERVAL_THORN) / DEF_ANIME_INTERVAL_THORN_DIV;

  for( i = 0; i < max; i++ )
    {
      sprite( g_gs.stage.thorn_p[i].x >> 16,
               g_gs.stage.thorn_p[i].y >> 16,
               g_chr_handle[ CHR_THORN + anime ] );
    }
}



/************************************************
 *	D\
 ***********************************************/
static void
draw_balloon( void )
{
  int i, anime, max = g_gs.stage.balloon_num;


  if( !g_gs.stage.balloon_num ) return;

  anime = (g_gs.anime_counter & DEF_ANIME_INTERVAL_BALLOON) / DEF_ANIME_INTERVAL_BALLOON_DIV;

  for( i = 0; i < max; i++ )
    {
      sprite( g_gs.stage.balloon_p[i].x >> 16,
               g_gs.stage.balloon_p[i].y >> 16,
               g_chr_handle[ CHR_BALLOON_100
                             + anime
                             + g_gs.stage.balloon_p[i].type * (CHR_BALLOON_400-CHR_BALLOON_100) ] );
    }
}



/************************************************
 *	X^[gC`
 ***********************************************/
static void
draw_start_point( void )
{
  Coord x = g_gs.player.start_x >> 16;
  Coord y = g_gs.player.start_y >> 16;

  sprite( x, y, g_chr_handle[ CHR_START ] );
}



/************************************************
 *	
 ***********************************************/
static void
init_stars( void )
{
  int i;


  for( i = 0; i < MAX_STAR; i++ )
    {
      g_gs.stage.star_p[i].x = (RND(160) +BACK_W_BLANK) *65536;
      g_gs.stage.star_p[i].y = (RND(128) +16+BACK_H_BLANK) *65536;
      g_gs.stage.star_p[i].color = INDEX_GREEN;
      g_gs.stage.star_p[i].speed = (RND(2)+1)*16384;
    }
}



/************************************************
 *	XN[
 ***********************************************/
static void
scroll_stars( void )
{
  int i;


  for( i = 0; i < MAX_STAR; i++ )
    {
      g_gs.stage.star_p[i].x += g_gs.stage.star_p[i].speed;
      if( g_gs.stage.star_p[i].x > (160+BACK_W_BLANK)*65536 )
        {
          g_gs.stage.star_p[i].x = BACK_W_BLANK*65536;
        }
    }
}



/************************************************
 *	`
 ***********************************************/
static void
draw_stars( void )
{
  int i;


  for( i = 0; i < MAX_STAR; i++ )
    {
      pset( g_gs.stage.star_p[i].x >> 16,
            g_gs.stage.star_p[i].y >> 16,
            g_gs.stage.star_p[i].color );
    }
}



/************************************************
 *	Aj
 ***********************************************/
static void
animetion( void )
{
  g_gs.anime_counter++;
}



/************************************************
 *	C
 ***********************************************/
static void
draw_sea( void )
{
  int i, anime;
  Coord x = BACK_W_BLANK, y = 160-12+BACK_H_BLANK;

  anime = (g_gs.anime_counter & DEF_ANIME_INTERVAL_BG) / DEF_ANIME_INTERVAL_BG_DIV;

  for( i = 0; i < 10; i++ )
    {
      sprite( x, y, g_chr_handle[ CHR_BG + anime ] );
      x += 16;
    }
}



