/******************************************************************************
 *
 *	Pocket Balloon
 *	color edition
 *	PalmOS 5
 *	ver 1.1.0
 *	2008. 4
 *	ChoiKyun
 *
 *****************************************************************************/

#ifndef INCLUDED_GAME_H
#define INCLUDED_GAME_H


#ifdef GLOBAL_VALUE_DEFINE
#define GLOBAL
#define GLOBAL_VAL(v) = (v)
#else
#define GLOBAL extern
#define GLOBAL_VAL(v)
#endif



/************************************************
 *	萔
 ***********************************************/
// PalmOne SDK
// 5-WAY
#define vchrRockerUp		0x0132		/**< 5-way rocker up */
#define vchrRockerDown		0x0133		/**< 5-way rocker down */
#define vchrRockerLeft		0x0134		/**< 5-way rocker left */
#define vchrRockerRight		0x0135		/**< 5-way rocker right */
#define vchrRockerCenter	0x0136		/**< 5-way rocker center/press */

#define keyBitRockerUp		0x00010000	// 5-way rocker up
#define keyBitRockerDown	0x00020000	// 5-way rocker down
#define keyBitRockerLeft	0x00040000	// 5-way rocker left
#define keyBitRockerRight	0x00080000	// 5-way rocker right
#define keyBitRockerCenter	0x00100000	// 5-way rocker center/press


// o[W
#define appFileCreator		'cK02'
#define appVersionNum		0x01
#define appPrefID		0x00
#define appPrefVersionNum	0x01


// o[W
#define ourMinVersion	sysMakeROMVersion(2,0,0,sysROMStageRelease,0)
#define PalmRomVer300	sysMakeROMVersion(3,0,0,sysROMStageRelease,0)
#define PalmRomVer350	sysMakeROMVersion(3,5,0,sysROMStageRelease,0)
#define PalmRomVer500	sysMakeROMVersion(5,0,0,sysROMStageDevelopment,0) // CLIE΍


// J[
#define TRANS_COLOR 223

#define INDEX_BLACK 215
#define INDEX_GRAY 218
#define INDEX_WHITE 0
#define INDEX_GREEN 192


// Cxg̃EFCg
#define DEF_EVENT_TICK 4 // 25fps
#define SEC 25


// XRAl[
#define DEF_NAME_LEN 5


// Q[̐istO
#define FLG_GAME_STOP (~1)
#define FLG_GAME_START 1
#define FLG_GAME_READY 2
#define FLG_GAME_CLEAR 4
#define FLG_GAME_OVER 8
#define FLG_GAME_PAUSE 16
#define FLG_GAME_TITLE 32
// Q[IʉtO
#define FLG_GAME_SE 128


// n[hL[
#define KEY_RIGHT keyBitHard3
#define KEY_LEFT keyBitHard2
#define KEY_UP keyBitPageUp
#define KEY_DOWN keyBitPageDown

#define KEY_1 keyBitHard1
#define KEY_2 keyBitHard2
#define KEY_3 keyBitHard3
#define KEY_4 keyBitHard4

// 5-WAY
#define KEY_NAV_RIGHT keyBitRockerRight
#define KEY_NAV_LEFT keyBitRockerLeft
#define KEY_NAV_CENTER keyBitRockerCenter


// LN^
#define MAX_BMP (36+1)

#define CHR_PLAYER_L 0
#define CHR_PLAYER_R 2
#define CHR_BALLOON_100 4
#define CHR_BUBBLE 6
#define CHR_THORN 8

#define CHR_SE_OFF 10
#define CHR_SE_ON 11

#define CHR_STATUS 12

#define CHR_NUM 13 //~20

#define CHR_START 23
#define CHR_BG 24

#define CHR_TITLE 26
#define CHR_PAUSE 27

#define CHR_BALLOON_400 28
#define CHR_CLOUD 30
#define CHR_THANDER 31
#define CHR_GAME_OVER 32
#define CHR_DEAD 33

#define CHR_FISH_0 34


// XRALO
#define MAX_RANKING 6


// obNXN[TCY
#define BACK_WIDTH (160+16+16)
#define BACK_HEIGHT (160+16+16)
 // E]16hbg
#define BACK_W_BLANK 16
#define BACK_H_BLANK 16


// XN[TCY
#define LCD_WIDTH 160
#define LCD_HEIGHT 160
// Q[EBhETCY
#define GAME_WIN_WIDTH 160
#define GAME_WIN_HEIGHT 160


// ʉf[^
#define SND_LENGTH 20


// tHgTCY
#define NUM_WIDTH (6+1)


// e평l
// obt@
#define MAX_THORN 30
#define MAX_BALLOON 30
#define MAX_THANDER 3
#define MAX_STAR 25


// @
#define DEF_PLAYER_X ((Int32)(90 + BACK_W_BLANK) << 16)
#define DEF_PLAYER_Y ((Int32)(112 + BACK_H_BLANK) << 16)
#define DEF_PLAYER_VX 0
#define DEF_PLAYER_VY 0
#define DEF_PLAYER_LEFT 0
#define DEF_PLAYER_RIGHT 2
#define DEF_PLAYER_KEY_REPEAT 3 // L[s[g̃EFCg

#define DEF_START_X ((Int32)(90 + BACK_W_BLANK) << 16)
#define DEF_START_Y ((Int32)(128 + BACK_H_BLANK) << 16)

// XN[x
#define DEF_SCROLL_INC (65536/1)

#define DEF_VY_JUMP (65536/1)
#define DEF_VX_LEFT (65536/2)
#define DEF_VX_RIGHT (65536/2)

#define DEF_LIMIT_VX 300
#define DEF_LIMIT_VY 500

#define DEF_GRAVITY (DEF_VY_JUMP/8)

#define DEF_FLAP_WAIT (DEF_PLAYER_KEY_REPEAT-1) // @͂΂ 

// Aj̊Ԋu
#define DEF_ANIME_INTERVAL_BG 31
#define DEF_ANIME_INTERVAL_BG_DIV 16
#define DEF_ANIME_INTERVAL_THORN 3
#define DEF_ANIME_INTERVAL_THORN_DIV 2
#define DEF_ANIME_INTERVAL_BALLOON 31
#define DEF_ANIME_INTERVAL_BALLOON_DIV 16
#define DEF_ANIME_INTERVAL_BUBBLE 15
#define DEF_ANIME_INTERVAL_BUBBLE_DIV 8

// Xe[W
#define DEF_NEW_OBJ_INTERVAL (9*1) // 9hbg
#define DEF_STAGE_LIMIT 26	// ŒXe[W̒

#define DEF_BONUS_COUNT 20	// {[iXJEg
#define DEF_BONUS_SCORE 10000	// {[iX

#define DEF_STOP_INTERVAL (SEC*5)// ~ 5sec

// N
#define DEF_RANK_UP_COUNT (12+12)// ̃N܂
#define DEF_RANK_NEXT_BLANK 12// 󔒃JEg


// _, 
#define DEF_CLOUD_SCROLL (DEF_SCROLL_INC)
#define DEF_THANDER_LIMIT 80 // ĂW

// 蔻p
#define PLAYER_WIDTH (15-1) // `
#define PLAYER_HEIGHT (16-1)
#define PLAYER2_WIDTH (15-1)
#define PLAYER2_HEIGHT (8-1)
#define BALLOON_WIDTH (10-1)
#define BALLOON_HEIGHT (11-1)
#define THANDER_WIDTH (6-1)
#define THANDER_HEIGHT (15-1)
#define BUBBLE_WIDTH (14-1)
#define BUBBLE_HEIGHT (14-1)

#define THORN_X_CENTER 4 // S _
#define THORN_Y_CENTER 3

#define FISH_BORDER ((114+BACK_H_BLANK)*65536)
#define DEF_FISH_COUNT (25*6)
#define FISH_INTERVAL 25
#define DEF_FISH_ENCOUNT (FISH_INTERVAL * 3)
#define DEF_FISH_Y_POS (135+BACK_H_BLANK)

#define GAME_OVER_BORDER (165*65536)

// EFCg
#define DEF_MES_WAIT (SEC/2) //bZ[Wp

// XRA
#define SCORE_BUBBLE 500


/************************************************
 *	}N
 ***********************************************/
// _
#define RND(N) ((((Int32) SysRandom (0)) * (N)) / ((Int32) sysRandomMax + 1))



/************************************************
 *	錾
 ***********************************************/
// xǗ
typedef struct
{
  int rank;		// xiNj
  int count;		// NAbvJEg
} LevelDataType;


// ʉԍ
typedef enum
{
  no_sound,		// Ȃ
  jump,			// Wv
  bound,		// ˕Ԃ
  balloon,		// ACe
  bonus,		// {[iX
  thorn,		// gQgQ
  tick,			// v
  over,			// Q[I[o[
  click,		// NbN
  sound_cnt
} SoundType;


// PSETO[XP[
typedef enum
{
  white,
  light_gray,		// 4KXP[
  dark_gray,
  black
} PsetColorType;


// PSET
typedef enum
{
  nomal,
  bold
} PsetWidthType;


// nCXRA
typedef struct
{
  char name[DEF_NAME_LEN+1];	// O
  UInt32 score;			// nCXRA
  char date[dateStringLength];	// t
} HiScoreType;


// @
typedef struct
{
  Int32 x;		// XW@*65536
  Int32 y;
  Int32 vx;		// x@*65536
  Int32 vy;
  int direc;		// 
  int anime_wait;	// Aj̃EFCg
  Boolean eat_flg;	// HׂtO
  Boolean dead_flg;	// Dj

  Int32 start_x;	// X^[gC
  Int32 start_y;
} PlayerType;


// GigQgQj
typedef struct
{
  int type;		// 0 Ȃ 1  -1 
  Int32 x;
  Int32 y;
  Int32 speed;
} ThornType;


// D
typedef struct
{
  int type;		// 0 100_ 1 400_
  Int32 x;
  Int32 y;
} BalloonType;


// _
typedef struct
{
  Boolean live_flg;	// tO
  Int32 x;
  Int32 y;
} CloudType;


// 
typedef struct
{
  Int32 x;
  Int32 y;
} ThanderType;


// Af[^
typedef struct
{
  Boolean live_flg;
  Int32 x;
  Int32 y;
} BubbleType;


// f[^
typedef struct
{
  Int32 x;
  Int32 y;
  PsetColorType color;
  Int32 speed;
} StarType;


// f[^
typedef struct
{
  Coord x;
  Coord y;
  int count; // o܂ł̃JEg
} FishType;


// Xe[Wf[^
typedef struct
{
  ThornType *thorn_p;		// Gf[^̃|C^
  BalloonType *balloon_p;	// Df[^̃|C^
  ThanderType *thander_p;	// f[^̃|C^
  StarType *star_p;		// f[^̃|C^

  FishType fish;		// f[^
  CloudType cloud;		// _f[^
  BubbleType bubble;		// Af[^

  int thorn_num;		// IuWFNg
  int balloon_num;
  int thander_num;

  int balloon_get_count;	// AQbgJEg

  int mode;			// 0 Gړ n GŒ+JEgp
  int new_interval;		// ̃IuWFNg̃Zbg܂
  int stop_interval;		// XN[~tO
} StageType;


// Q[̐is
typedef struct
{
  UInt16 start;			// Q[istO
  UInt32 key;			// L[tO
  UInt32 keyf;			// L[tO2
  Boolean pen_down;		// ytO
  Boolean pen_move;
  Int16 pen_x;			// yXW
  Int16 pen_y;			// yYW

  SoundType se;			// ʉԍ
  Int16 se_repeat;		// ʉJEgit[j
  Boolean over_se;		// Q[I[o[̌ʉ

  PlayerType player;		// @f[^
  StageType stage;		// Xe[Wf[^

  int anime_counter;		// AjpJE^

  LevelDataType lv;		// x
  UInt32 score;			// XRA

				//// ȉvt@Xɕۑ

  char last_name[ DEF_NAME_LEN+1 ];	// Ōɓ͂O
  Int16 rank_pos;			// LO݈ʒu
  HiScoreType ranking[ MAX_RANKING ];	// XRALO
  Boolean sound;		// ʉtO
} GameStateType;


// Q[vt@@X
typedef struct
{
  char last_name[ DEF_NAME_LEN+1 ];
  Int16 rank_pos;
  HiScoreType ranking[ MAX_RANKING ];
  Boolean sound;
} GamePrefType;


// ʃ[h̕ۑ
typedef struct
{
  UInt32 width;
  UInt32 height;
  UInt32 depth;
} ScreenModeType;



/************************************************
 *	O[oϐ
 ***********************************************/
// ʃ[h̕ۑ
GLOBAL ScreenModeType g_save_screen;

// OS3.5ȍ~
//GLOBAL Boolean g_pre_35 GLOBAL_VAL(false);

// obNXN[nh
GLOBAL WinHandle g_back_screen_h;

// obNXN[|C^
//GLOBAL UInt32 *g_back_screen_p;
// LCDobt@|C^
//GLOBAL UInt32 *g_lcd_screen_p;

// Cxg[ṽC^[o
GLOBAL Int32 g_event_interval;

// Q[̐is
GLOBAL GameStateType g_gs;

// rbg}bvLN^nh
GLOBAL WinHandle g_chr_handle[ MAX_BMP ];

// TEh̃{[
GLOBAL UInt16 g_volume;

// bZ[W\EFCg
GLOBAL Int16 g_mes_wait;

// 5-WAY Z^[L[dh~tO
GLOBAL Boolean g_first_center;



/************************************************
 *	vg^Cv
 ***********************************************/
// starter.c
UInt32 PilotMain( UInt16, MemPtr, UInt16 );
void get_hard_key( void );		// n[hL[擾


// game.c
void init_game_status( void );		// Q[
void set_start_position( void );	// ͂΂iHj
void play_game( void );			// Q[C
void pre_start( void );			// Q[JnO̕\,XN[
void title_back( void );		// ^Cg̃obN\


// graphic.c
Err init_screen( void );		// XN[
void clear_screen( void );		// SʃNAiobNXN[j
void copy_buff_to_lcd( void );		// LCD]
void sprite( Coord, Coord, WinHandle );// LN^`i16*8 or 16*16 2bitj
void pset( Coord, Coord,
           IndexedColorType );		// PSET


// sound.c
void change_se( void );			// ʉ؂ւ
void set_se( SoundType );		// ʉZbg
void sound( void );			// ʉit[j


// score.c
void init_hiscore( void );		// nCXRA
void check_hiscore( UInt32 );		// nCXRAXV
void show_ranking( void );		// LO\
void show_num2( Coord, Coord, Int16 );	// Ql\
void show_num7( Coord, Coord, UInt32 );	// Vl\


// message.c
Boolean select_game_event( void );	// e탁bZ[W
void show_status( void );		// Xe[^X\



#undef GLOBAL
#undef GLOBAL_VAL



#endif // INCLUDED_GAME_H
