/******************************************************************************
 *
 *	Pocket Balloon
 *	color edition
 *	PalmOS 5
 *	ver 1.1.0
 *	2008. 4
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
void show_mes_ready( void );
void show_mes_over( void );
void show_mes_clear( UInt32 );
void print_press( void );
void print_pause( void );
void print_title( void );
Boolean ready( void );

void over_sound( void );



/******************************************************************************
 *	O[oȒ萔
 *****************************************************************************/



/************************************************
 *	Q[Cxg
 ***********************************************/
Boolean
select_game_event( void )
{
  Boolean result = false;
  UInt16 cmd = g_gs.start & FLG_GAME_STOP;
  UInt32 save_key, save_keyf;


  // bZ[WEFCg
  if( g_mes_wait )
    {
      g_mes_wait--;
      return result = true;
    }

  switch( cmd )
    {
    case FLG_GAME_TITLE:
      title_back();
      print_title();	// ^Cg\

      if( ready() )
        {
          g_gs.start = FLG_GAME_START | FLG_GAME_READY;
        }
      result = true;
      break;

    case FLG_GAME_READY:
      pre_start();	// Q[JnO̕\,XN[

      if( ready() )
        {
          set_start_position();
          g_gs.start = FLG_GAME_START;
        }
      result = true;
      break;

    case FLG_GAME_OVER:
      over_sound();
      show_mes_over();	// bZ[W

      if( ready() )
        {
          check_hiscore( g_gs.score );

          g_gs.start = FLG_GAME_START | FLG_GAME_TITLE;
          save_key = g_gs.key, save_keyf = g_gs.keyf;
          clear_screen();
          // Q[
          init_game_status();
          g_gs.key = save_key, g_gs.keyf = save_keyf;
        }
      result = true;
      break;

    case FLG_GAME_PAUSE | FLG_GAME_READY:
    case FLG_GAME_PAUSE:
      print_pause();
      result = true;
      break;
    }

  return result;
}



/************************************************
 *	Xe[^Xʕ\
 ***********************************************/
void
show_status( void )
{
  sprite( BACK_W_BLANK, BACK_H_BLANK, g_chr_handle[ CHR_STATUS ] );

  // RANK
  show_num2( 35+BACK_W_BLANK, 1+BACK_H_BLANK, g_gs.lv.rank );
  // SCORE
  show_num7( 95+BACK_W_BLANK, 1+BACK_H_BLANK, g_gs.score );

  // ʉACR
  sprite( 159-8+BACK_W_BLANK,
          1+BACK_H_BLANK,
          g_chr_handle[ g_gs.sound + CHR_SE_OFF ] );
}



/********************************************************************
 *	X^[eBbNȊ֐Q
 *******************************************************************/

/************************************************
 *	Q[JnO
 ***********************************************/
static Boolean
ready( void )
{
  // Q[Jn L[́y^bv
  if( g_gs.keyf & ( KEY_1
                    | KEY_2
                    | KEY_3
                    | KEY_4
                    | KEY_NAV_RIGHT
                    | KEY_NAV_LEFT
                    | KEY_NAV_CENTER )
      || (g_gs.pen_down && g_gs.pen_y > 16+BACK_H_BLANK ) )
    {
      // ʂ̏
//      clear_screen();
      g_gs.pen_down = false;
      set_se( click );

      return true;
    }

  return false;
}



/************************************************
 *	bZ[W\-Q[JnO
 ***********************************************/
static void
show_mes_ready( void )
{
  // PRESS...
  print_press();
}



/************************************************
 *	bZ[W\-Q[I[o[
 ***********************************************/
static void
show_mes_over( void )
{
  sprite( 35+BACK_W_BLANK, 65+BACK_H_BLANK, g_chr_handle[ CHR_GAME_OVER ] );

  // PRESS...
  print_press();
}



/************************************************
 *	^Cg\
 ***********************************************/
static void
print_title( void )
{
  WinHandle save;
  FontID id;
  static const char mes_sub1[] = { "for Palm series" };

  // ^Cg
  sprite( 4+BACK_W_BLANK, 40+BACK_H_BLANK, g_chr_handle[ CHR_TITLE ] );

  id = FntSetFont( boldFont );
  save = WinGetDrawWindow();
  WinSetDrawWindow( g_back_screen_h );

  WinPushDrawState();
  WinSetTextColor( INDEX_WHITE );
  WinSetBackColor( INDEX_BLACK );

  WinPaintChars( mes_sub1, StrLen( mes_sub1 ), 78+BACK_W_BLANK, 92+BACK_H_BLANK );

  FntSetFont( id );
  WinPopDrawState();
  WinSetDrawWindow( save );

  // PRESS...
  print_press();
}



/************************************************
 *	bZ[W\ PRESS...
 ***********************************************/
static void
print_press( void )
{
  WinHandle save;
  FontID id;
  static const char mes_pause[] = {
    "Press any key or tap screen" };


  id = FntSetFont( boldFont );

  save = WinGetDrawWindow();
  WinSetDrawWindow( g_back_screen_h );

  WinPushDrawState();
  WinSetTextColor( INDEX_WHITE );
  WinSetBackColor( INDEX_BLACK );

  WinPaintChars( mes_pause, StrLen( mes_pause ), 12+BACK_W_BLANK, 145+BACK_H_BLANK );

  FntSetFont( id );
  WinPopDrawState();
  WinSetDrawWindow( save );
}



/************************************************
 *	bZ[W\ PAUSE
 ***********************************************/
static void
print_pause( void )
{
  sprite( 58+BACK_W_BLANK, 60+BACK_H_BLANK, g_chr_handle[ CHR_PAUSE ] );
}



/************************************************
 *	Q[I[o[̌ʉ
 ***********************************************/
static void
over_sound( void )
{
  if( g_gs.over_se )
    {
      set_se( over );
      g_gs.over_se = false;
    }
}



