/******************************************************************************
 *
 *	Pocket Balloon
 *	color edition
 *	PalmOS 5
 *	ver 1.1.0
 *	2008. 4
 *	ChoiKyun
 *
 *****************************************************************************/
#include <PalmOS.h>
#include <PalmOSGlue.h>
#include "defrsc.h"

//#define GLOBAL_VALUE_DEFINE
#include "game.h"



/******************************************************************************
 *	vg^Cv
 *****************************************************************************/
void init_hiscore( void );			// nCXRA
void input_name( void );			// O
Boolean score_ranking_handler( EventPtr );	// nh
Boolean score_name_handler( EventPtr );
void clear_hiscore( void );			// LONA



/************************************************
 *	Ql\ obNXN[
 ***********************************************/
void
show_num2( Coord x, Coord y, Int16 num )
{
  sprite( x+NUM_WIDTH, y, g_chr_handle[ CHR_NUM + (num % 10) ] );
  num /= 10;
  sprite( x, y, g_chr_handle[ CHR_NUM + num ] );
}



/************************************************
 *	Vl\
 ***********************************************/
void
show_num7( Coord x, Coord y, UInt32 num )
{
  int i, pos = 6 * NUM_WIDTH;


  for( i = 0; i < 7; i++ )
    {
      sprite( x+pos, y, g_chr_handle[ CHR_NUM + (num % 10) ] );
      num /=10;
      pos -= NUM_WIDTH;
    }
}



/************************************************
 *	nCXRAF
 ***********************************************/
void
init_hiscore( void )
{
  int i;


  for( i = 0; i < MAX_RANKING; i++ )
    {
      g_gs.ranking[i].name[0] = '\0'; // k
      g_gs.ranking[i].score = 0;
      g_gs.ranking[i].date[0] = '\0';
    }

  g_gs.rank_pos = 0;
  StrCopy( &g_gs.last_name, "-----" );
}



/************************************************
 *	nCXRAFǉ
 ***********************************************/
void
check_hiscore( UInt32 score )
{
  int pos = MAX_RANKING;
  DateTimeType date;


  // nCXRÃ`FbN
  while( pos > 0
         && score > g_gs.ranking[ pos-1 ].score )
    {
      pos--; // 
    }
  if( pos >= MAX_RANKING ) return;

  // ʈړ
  MemMove( &g_gs.ranking[ pos+1 ],
           &g_gs.ranking[ pos ],
           sizeof( HiScoreType ) * (MAX_RANKING - pos - 1) );

  // O̓
  input_name();
  StrCopy( &g_gs.ranking[ pos ].name, &g_gs.last_name );
  // nCXRAXV
  g_gs.ranking[ pos ].score = score;

  // ̍XV
  TimSecondsToDateTime( TimGetSeconds(), &date );
  DateToAscii( date.month,
               date.day,
               date.year,
               dfYMDWithSlashes,
               &g_gs.ranking[ pos ].date );

  g_gs.rank_pos = pos;
  // XRALO\
  show_ranking();
}



/************************************************
 *	XRALO\
 ***********************************************/
void
show_ranking( void )
{
  FormPtr save_form_p,form_p;
  Coord y;
  int i;
  char score_string[8];
  FontID old_font;


  // ݂̃tH[̕ۑ
  save_form_p = FrmGetActiveForm();
  // LOtH[
  form_p = FrmInitForm( Rank_bordForm );
  FrmSetActiveForm( form_p );
  FrmDrawForm( form_p );

  WinDrawGrayLine( 5, 31, 156-5, 31 );
  // LO`
  for( i = 0; i < MAX_RANKING; i++ )
    {
      if( !g_gs.ranking[i].score ) break;

      if( g_gs.rank_pos == i )
        old_font = FntSetFont( boldFont ); // Jg͑
      else
        old_font = FntSetFont( stdFont );

      y = i * 16 + 33;
      // AXL[ϊ
      StrIToA( score_string, g_gs.ranking[i].score );
      StrCat( score_string, "." );

      // O
      WinDrawChars( &g_gs.ranking[i].name,
                    StrLen( &g_gs.ranking[i].name ),
                    16,
                    y );

      // XRA
      WinDrawChars( score_string,
                    StrLen( &score_string ),
                    108 - FntCharsWidth( &score_string, StrLen( &score_string ) ),
                    y );
      // t
      WinDrawChars( &g_gs.ranking[i].date,
                    StrLen( &g_gs.ranking[i].date ),
                    151 - FntCharsWidth( &g_gs.ranking[i].date, StrLen( &g_gs.ranking[i].date ) ),
                    y );

      FntSetFont( old_font ); // tHgA
    }

  // nhݒ
  FrmSetEventHandler( form_p, score_ranking_handler );

  FrmDoDialog( form_p );

  FrmDeleteForm( form_p );
  FrmSetActiveForm( save_form_p );
}



/********************************************************************
 *	X^[eBbNȊ֐Q
 *******************************************************************/

/************************************************
 *	nCXRAFO
 ***********************************************/
static void
input_name( void )
{
  FormPtr save_form_p,input_p;
  MemHandle name_h;
  char *name_p;
  UInt16 index, button;


  // ݂̃tH[Ҕ
  save_form_p = FrmGetActiveForm();

  // tH[
  input_p = FrmInitForm( Input_nameForm );
  // tB[hINDEX
  index = FrmGetObjectIndex( input_p, input_nameFieldField );
  // tH[JX
  FrmSetFocus( input_p, index );
  // KtBeBXe[g
  GrfSetState( false, false, true );

  g_first_center = true; // Z^[L[dh~
  // Cxgnhݒ
  FrmSetEventHandler( input_p, score_name_handler );
  // O̓_CAO\
  button = FrmDoDialog( input_p );

  // nh擾
  name_h = FldGetTextHandle( FrmGetObjectPtr( input_p, index) );
  // nh؂藣
  FldSetTextHandle( FrmGetObjectPtr( input_p, index ), 0 );
  // _CAO폜
  FrmDeleteForm( input_p );
  FrmSetActiveForm( save_form_p );

  if( name_h != NULL )
    {
      name_p = MemHandleLock( name_h ); // |C^擾
      if( name_p[0] != '\0' && button == input_nameOkButton )
        {
          // ÕRs[
          StrCopy( &g_gs.last_name, name_p );
        }
      MemHandleFree( name_h ); // nh
    }
}



/************************************************
 *	XRALÕnh
 ***********************************************/
static Boolean
score_ranking_handler( EventPtr event_p )
{
  if( event_p ->eType == ctlSelectEvent )
    {
      if( event_p ->data.ctlSelect.controlID == rank_bordClearButton )
        {
          // A[g\
          if( FrmAlert( Clear_rankingAlert ) == Clear_rankingYes )
            clear_hiscore();

          return true;
        }
    }
  return false;
}



/************************************************
 *	XRAl[̃nh
 ***********************************************/
static Boolean
score_name_handler( EventPtr event_p )
{
  Boolean handled = false;
  UInt32 key;

  key = KeyCurrentState();
  if( key & ( KEY_1|KEY_2|KEY_3|KEY_4|KEY_NAV_LEFT|KEY_NAV_RIGHT|KEY_UP|KEY_DOWN ) )
    g_first_center = false;

  if( event_p ->eType == keyDownEvent )
    {
      if( TxtGlueCharIsVirtual( event_p ->data.keyDown.modifiers,
                                event_p ->data.keyDown.chr) )
        {
          switch( event_p ->data.keyDown.chr )
            {
            case vchrHard1: // n[hL[}XN@ꂵ
            case vchrHard2:
            case vchrHard3:
            case vchrHard4:
            case vchrPageDown:
            case vchrPageUp:
              handled = true;
              break;

            case vchrRockerCenter: // Z^[L[dɂȂ̂h~
              if( g_first_center )
                {
                  g_first_center = false;
                  handled = true;
                }
            }
        }
    }

  return handled;
}



/************************************************
 *	nCXRANA
 ***********************************************/
static void
clear_hiscore( void )
{
  int i;
  RectangleType r;


  for( i = 0; i < MAX_RANKING; i++ )
    {
      g_gs.ranking[i].name[0] = '\0'; // k
      g_gs.ranking[i].score = 0;
      g_gs.ranking[i].date[0] = '\0';
    }

  r.topLeft.x = 10; r.topLeft.y = 33;
  r.extent.x = 151-10; r.extent.y = 139-33;
  WinEraseRectangle(&r, 0);
}



